'Wed  Jul 19, 1989   9:01:28 am          
'                            
'*****************************************************************************
'MAKEHELP makes a random access file of external help screens for a QB program
'*****************************************************************************

DECLARE FUNCTION exists! (filename$)
DECLARE SUB filebusiness ()
DECLARE SUB header ()
DECLARE FUNCTION newtime$ (intime$)
DECLARE SUB helpscreen ()
DECLARE SUB goodbye ()

CONST yes = 1, no = 0

TYPE regtype
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE

TYPE record
        lines AS STRING * 80
END TYPE

DIM SHARED inregs AS regtype, outregs AS regtype, text AS record

COMMON SHARED infile$, infile, outfile$, outfile, start, finish, lines

'************************* MAIN PROGRAM BEGINS HERE *************************
     CLS
     filebusiness
     header
     start = TIMER
     WHILE NOT EOF(infile)
          LINE INPUT #infile, inline$
          lines = lines + 1
          LOCATE 3, 17: PRINT lines;
          LSET text.lines = inline$
          PUT #outfile, lines, text
     WEND
     goodbye
'************************* MAIN PROGRAM ENDS HERE ***************************

FUNCTION exists (filename$)
     f$ = filename$ + CHR$(0)
     inregs.ax = &H1100: inregs.dx = SADD(f$)
     CALL interrupt(&H21, inregs, outregs)
     handle = outregs.ax
    
     inregs.bx = handle
     inregs.ax = &H4E00
     CALL interrupt(&H21, inregs, outregs)
     f = outregs.ax
     IF f = 0 THEN f = 1 ELSE f = 0
     exists = f
END FUNCTION

SUB filebusiness
        infile$ = COMMAND$
        IF infile$ = "" THEN helpscreen
        IF exists(infile$) = no THEN
                 PRINT "ERROR: No file by that name found."
                 helpscreen
        END IF
        infile = FREEFILE
        OPEN infile$ FOR INPUT AS infile
        outfile$ = "HELPFILE"
        outfile = FREEFILE
        OPEN outfile$ FOR RANDOM AS outfile LEN = 80
END SUB

SUB goodbye
     PRINT ""
     finish = TIMER
     PRINT "Process rate:"; FIX(lines / (finish - start)); "per second"
     CLOSE
     END
END SUB

SUB header
     COLOR 15: PRINT "MAKEDOC "; : COLOR 7: PRINT "makes a random access help file for an ASCII text file."
     PRINT "Converting "; infile$; " to "; outfile$
     PRINT "Processing line:"
END SUB

SUB helpscreen
     PRINT "MAKEHELP makes a random access help file from an ASCII text file"
     PRINT "for use as external help in QB programs. (c) 1989 David Wesson"
     PRINT " "
     PRINT "Syntax: MAKEHELP  [d:]textfile.ext "
     PRINT " where  textfile.ext =  full text file name  [drive optional] "
     PRINT ""
     PRINT "NOTE: The program creates a random file of record length 80."
     END
END SUB

FUNCTION newtime$ (intime$)
      hour$ = MID$(intime$, 1, 2)
      min$ = MID$(intime$, 4, 2)
      sec$ = MID$(intime$, 7, 2)
      hour = VAL(hour$)
           IF hour < 12 THEN ampm$ = "am" ELSE ampm$ = "pm"
           IF hour > 12 THEN hour = hour - 12
      hour$ = STR$(hour)
      newtime$ = hour$ + ":" + min$ + ":" + sec$ + " " + ampm$
END FUNCTION

